"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateInput = void 0;
const react_1 = __importDefault(require("react"));
const react_hook_form_1 = require("react-hook-form");
const dBDateToVisual_1 = require("./utils/dBDateToVisual");
const dateConverterNew_1 = require("./utils/dateConverterNew");
const transferAsIDate = {
    output: (value) => {
        return { display: value, database: value };
    },
    outputOnBlur: (value) => {
        return (0, dateConverterNew_1.dateDisplayNewFormat)(value);
    },
    input: (value) => {
        return value.dispDate;
    }
};
const transferAsString = {
    output: (value) => {
        if (!dBDateToVisual_1.DBDateFormat.test(value))
            return value;
        else
            return (0, dateConverterNew_1.dateDisplayNewFormat)(value).dataDate;
    },
    outputOnBlur: (value) => {
        return (0, dateConverterNew_1.dateDisplayNewFormat)(value).dataDate;
    },
    input: (value) => {
        return (0, dBDateToVisual_1.dbDateToVisual)(value);
    }
};
const DateInput = ({ placeHolder, name, maxDate, minDate, defaultValue, format = 'DB' }) => {
    const formContext = (0, react_hook_form_1.useFormContext)();
    const transferMethods = format === 'DB' ? transferAsString : transferAsIDate;
    const myval = formContext.watch(name);
    console.log(myval);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        placeHolder,
        react_1.default.createElement(react_hook_form_1.Controller, { name: name, control: formContext.control, rules: {
                max: maxDate,
                min: minDate
            }, defaultValue: defaultValue, render: ({ field }) => (react_1.default.createElement("input", Object.assign({ type: "text" }, field, { value: field.value ? transferMethods.input(field.value) : "", onChange: e => {
                    field.onChange(transferMethods.output(e.target.value));
                }, onBlur: e => field.onChange(transferMethods.outputOnBlur(e.target.value)) }))) })));
};
exports.DateInput = DateInput;
//# sourceMappingURL=DateInput.js.map